<?php

namespace App\DataTables;

use App\Models\Fattura;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Validation\Rule;
use Yajra\DataTables\DataTablesEditor;
use Illuminate\Http\Request;
use Illuminate\Validation\ValidationException;
use Storage;
use Illuminate\Support\Str;

class FatturaDataTableEditor extends DataTablesEditor
{
  protected $model = Fattura::class;
  // protected $uploadDir = '';
  // protected $disk = 'modelliRicevute';

  protected $messages = [
    'numero_fattura.required' => 'Il numero della fattura è richiesto',
    'data_fattura.required' => 'La data della fattura è richiesta',
    'stato.required' => 'Lo stato della fattura è richiesto',
    'note.required' => 'La nota della fattura è richiesta',
    'path_pdf.required' => 'Il percorso del PDF della fattura è richiesto',
    'path_xml.required' => 'Il percorso del XML della fattura è richiesto',
    'metadata.required' => 'I metadati della fattura sono richiesti',
    'totale_imponibile.required' => 'Il totale imponibile della fattura è richiesto',
    'totale_netto.required' => 'Il totale netto della fattura è richiesto',
  ];

  /**
  * Get create action validation rules.
  *
  * @return array
  */
  public function createRules(): array
  {
    return [
      'numero_fattura'  => 'required',
      'data_fattura' => 'required',
      'stato' => 'required',
      'note' => 'nullable',
      // 'path_pdf' => 'required',
      // 'path_xml' => 'required',
      // 'metadata' => 'required',
      // 'totale_imponibile' => 'required',
      // 'totale_netto' => 'required',
    ];
  }

  public function createMessages(): array{
    return $this->messages;
  }

  /**
  * Get edit action validation rules.
  *
  * @param Model $model
  * @return array
  */
  public function editRules(Model $model): array
  {
    return [
      'numero_fattura'  => 'required',
      'email' => 'nullable|email',
      'note' => 'nullable',
      // 'path_pdf' => 'required',
      // 'path_xml' => 'required',
      // 'metadata' => 'required',
      // 'totale_imponibile' => 'required',
      // 'totale_netto' => 'required',
    ];
  }

  public function editMessages(): array{
    return $this->messages;
  }

  /**
  * Get remove action validation rules.
  *
  * @param Model $model
  * @return array
  */
  public function removeRules(Model $model): array
  {
    return [];
  }

  public function creating(Model $model, array $data): array
  {
    // $model->roles()->sync([$data['ruolo_id']]);
    return $data;
  }

  public function updating(Model $model, array $data): array
  {
    // dd($data['ruolo']);
    // $model->roles()->sync([$data['ruolo_id']]);
    return $data;
  }
  public function messages(): array
  {
    return $this->messages;
  }

}
